#############################################
############## radio-0.8c.tcl ###############
#############################################
# This is the client part of radio-0.8.tcl! #
#############################################

# Auf welchem Chan soll der Bot auf die Radio-Befehle reagieren?
set radio:chan "#radio4life"

# Wie heit das Radio?
set radio:name "Radio4Life"

# Wie ist die Homepage des Radios?
set radio:url "http://www.radio4life.de/"

# Wo wird das Radio gestreamt? (ohne listen.pls)
set radio:stream "http://radio4life.dyn.ee:22000/"

# Welcome-Message an?
set radio:welcome "0"

# Nicht ndern!
set radio:dj ""
set radio:nextdj ""

# Radio standardmig nicht online
set radio:off "1"

# Soll das Topic beim ndern des DJs gendert werden?
set radio:set:topic "1"

# In welcher Datei soll das Topic gespeichert werden?
set radio:topicfile "radio.topic"

########################
# Script beginnt hier! #
########################
bind pub -|- !url radio:pub:url
bind pub -|- !stream radio:pub:stream
bind pub -|- !dj radio:pub:dj
bind pub -|- !wunsch radio:pub:wunsch
bind pub -|- !gru radio:pub:gruss
bind pub -|- !gruss radio:pub:gruss
bind pub -|- !info radio:pub:info
bind pub -|- !nextdj radio:pub:nextdj
bind pub -|- !status radio:pub:status
bind pub -|- !act radio:pub:act
bind join -|- * radio:join:welcome
bind bot - radio_status radio:net:status
bind bot - radio_dj radio:net:dj
bind bot - radio_nextdj radio:net:nextdj
bind bot - radio_next radio:net:next
bind bot - radio_topic radio:net:topic
bind link - * radio:net:askstatus

proc radio:pub:url {nick host hand chan arg} {
	global radio:name radio:url radio:chan
	if {$chan == ${radio:chan}} {
		puthelp "NOTICE $nick :Die Homepage von ${radio:name} ist unter ${radio:url} zu erreichen."
	}
}

proc radio:pub:stream {nick host hand chan arg} {
	global radio:name radio:stream radio:off radio:chan
	if {$chan == ${radio:chan}} {
		if {${radio:off}} {
			puthelp "NOTICE $nick :Das Radioscript ist momentan nicht aktiviert."
			return 0
		}
		puthelp "NOTICE $nick :Den Stream von ${radio:name} kannst du dir unter ${radio:stream}listen.pls reinziehen!"
	}
}

proc radio:pub:dj {nick host hand chan arg} {
	global radio:dj radio:off radio:chan
	if {$chan == ${radio:chan}} {
		if {${radio:off}} {
			puthelp "NOTICE $nick :Das Radioscript ist momentan nicht aktiviert."
			return 0
		}
		puthelp "NOTICE $nick :Momentan drhnt euch \002${radio:dj}\002 mit seiner/ihrer Musik zu!"
	}
}

proc radio:pub:wunsch {nick host hand chan arg} {
	global radio:name radio:dj radio:off radio:chan radio:wunsch
	set radio:wunsch "$arg"
	if {$chan == ${radio:chan}} {
		if {${radio:off}} {
			puthelp "NOTICE $nick :Das Radioscript ist momentan nicht aktiviert."
			return 0
		}
		if {${radio:wunsch} == ""} {
			puthelp "NOTICE $nick :Du hast keinen Titel angegeben!"
			return 0
		}
		putallbots "radio_wunsch $nick ${radio:wunsch}"
		puthelp "NOTICE $nick :Dein Wunsch \002${radio:wunsch}\002 wurde an ${radio:dj} weitergeleitet. Bitte wnsche dir das nicht noch einmal, da wir den Wunsch sonst ignorieren werden!"
	}
}

proc radio:pub:gruss {nick host hand chan arg} {
	global radio:name radio:dj radio:off radio:chan radio:gruss
	set radio:gruss "$arg"
	if {$chan == ${radio:chan}} {
		if {${radio:off}} {
			puthelp "NOTICE $nick :Das Radioscript ist momentan nicht aktiviert."
			return 0
		}
		if {${radio:gruss} == ""} {
			puthelp "NOTICE $nick :Du hast keinen Gru angegeben!"
			return 0
		}
		putallbots "radio_gruss $nick ${radio:gruss}"
		puthelp "NOTICE $nick :Dein Gru \002${radio:gruss}\002 wurde an ${radio:dj} weitergeleitet. Bitte wnsche dir das nicht noch einmal, da wir deinen Gru sonst ignorieren werden!"
	}
}

proc radio:join:welcome {nick uhost hand chan} {
	global radio:name radio:chan botnick radio:welcome
	if {$nick == $botnick} {return 0}
	if {${radio:welcome} == "0"} {return 0}
	if {$chan == ${radio:chan}} {
		puthelp "NOTICE $nick :Willkommen in ${radio:chan}, dem IRC-Channel von ${radio:name}! Dir stehen folgende Befehle zur Verfgung:"
		puthelp "NOTICE $nick :Mit \002!url\002 kannst du dir die URL zum Channel anzeigen lassen, \002!stream\002 zeigt dir an, wo du das Radio hren kannst, \002!dj\002 sagt dir, wer die Musik auflegt und \002!nextdj\002 zeigt dir, wer den DJ danach ablst. Auerdem kannst du mit \002!wunsch\002 Musikwnsche und mit \002!gru\002 Gre an den/die Moderator(in) weitergeben."
	}
}

proc radio:pub:info {nick host hand chan arg} {
	global radio:name radio:url radio:chan
	if {$chan == ${radio:chan}} {
		puthelp "NOTICE $nick :Dir stehen folgende Befehle zur Verfgung:"
		puthelp "NOTICE $nick :Mit \002!url\002 kannst du dir die URL zum Channel anzeigen lassen, \002!stream\002 zeigt dir an, wo du das Radio hren kannst, \002!dj\002 sagt dir, wer die Musik auflegt und \002!nextdj\002 zeigt dir, wer den DJ danach ablst. Auerdem kannst du mit \002!wunsch\002 Musikwnsche und mit \002!gru\002 Gre an den/die Moderator(in) weitergeben."
	}
}

proc radio:pub:nextdj {nick host hand chan arg} {
	global radio:name radio:chan radio:nextdj radio:dj radio:off
	if {$chan == ${radio:chan}} {
		if {${radio:off}} {
			puthelp "NOTICE $nick :Das Radioscript ist momentan nicht aktiviert."
			return 0
		}
		if {${radio:nextdj} == ""} {
			puthelp "NOTICE $nick :Es wurde noch keine Ablsung fr ${radio:dj} eingesetzt."
			return 0
		}
		putquick "NOTICE $nick :${radio:nextdj} wird ${radio:dj} nachher ablsen."
	}
}

proc radio:pub:status {nick host hand chan arg} {
	global radio:dj radio:nextdj radio:off
	if {$chan == ${radio:chan}} {
		puthelp "NOTICE $nick :Moderator: \002${radio:dj}\002, nchster Moderator: \002${radio:nextdj}\002, Status: \002${radio:off}\002"
	}
}

proc radio:pub:act {nick host hand chan arg} {
	if {$chan == ${radio:chan}} {
		putbot Info "radio_status"
	}
}

proc radio:net:status {bot com arg} {
	global radio:off radio:dj radio:chan
	global radio:set:topic radio:topicfile
	if {$arg == "on"} { set radio:off 0 }
	if {$arg == "off"} {
		set radio:off 1
		if {${radio:set:topic} == "1"} {
			source ${radio:topicfile}
			putserv "TOPIC ${radio:chan} :${radio:topic}"
			set radio:dj "offline"
		}
		set radio:dj ""
	}
}

proc radio:net:dj {bot com arg} {
	global radio:name radio:dj radio:nextdj radio:off radio:chan radio:url radio:stream
	global radio:topicfile radio:topic radio:set:topic
	set radio:dj "$arg"
	if {${radio:off}} {
		puthelp "PRIVMSG ${radio:chan} :Das Radio ist jetzt ONLINE! Euer DJ ist ${radio:dj}."
	}
	set radio:off "0"
	if {${radio:set:topic} == "1"} {
		source ${radio:topicfile}
		putserv "TOPIC ${radio:chan} :${radio:topic}"
	}
}

proc radio:net:nextdj {bot com arg} {
	global radio:name radio:nextdj radio:off radio:chan
	set radio:nextdj "$arg"
}

proc radio:net:next {bot com arg} {
	global radio:name radio:dj radio:nextdj radio:off radio:chan radio:stream radio:url
	global radio:topicfile radio:topic radio:set:topic
	set radio:dj "${radio:nextdj}"
	set radio:nextdj ""
	puthelp "PRIVMSG ${radio:chan} :Das Radio ist jetzt ONLINE! Euer DJ ist ${radio:dj}."
	if {${radio:set:topic} == "1"} {
		source ${radio:topicfile}
		putserv "TOPIC ${radio:chan} :${radio:topic}"
	}
}

proc radio:net:topic {bot com arg} {
	global radio:chan radio:dj radio:name radio:stream radio:url
	global radio:topicfile radio:topic radio:set:topic
	if {${radio:set:topic} == "1"} {
		file delete ${radio:topicfile}
		set radio:openfile [open ${radio:topicfile} w]
		close ${radio:openfile}
		set radio:openfile [open ${radio:topicfile} a+]
		set radio:temptopic "set radio:topic \"$arg\""
		puts ${radio:openfile} ${radio:temptopic}
		close ${radio:openfile}
		source ${radio:topicfile}
	}
}

proc radio:net:askstatus {botlinked via} {
	putbot $botlinked "radio_status"
}

# History:
#
# Version 0.8c: Erste Version und erstes Release dieser Datei.
#
###########################################################################################
# Die Datei msste korrekter Weise radio-0.1c.tcl oder so hnlich heien, aber da ich die #
# Versionen quivalent zu einander machen muss, bekommt der Client Part (diese Datei) die #
# selbe Versionsnummer wie der Main Part!						  #
###########################################################################################

set radio:version "0.8c"
putlog "Radioscript ${radio:version} von Hangman5386 geladen."
